



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>JS中的特殊类别注意区分</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">JS中的特殊类别注意区分</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-02 08:48:12 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>undefined和null</h2>
<p>在JavaScript中存在这样两种原始类型：Null与Undefined。</p>
<p>这两种类型常常会使JavaScript的开发人员产生疑惑，在什么时候是Null，什么时候又是Undefined?</p>
<p>Undefined类型只有一个值，即undefined。当声明的变量还未被初始化时，变量的默认值为undefined。</p>
<p>Null类型也只有一个值，即null。null用来表示尚未存在的对象，常用来表示函数企图返回一个不存在的对象。</p>
<p>js 代码</p>
<div>
<pre class="prettyprint linenums">var oValue;<br />
alert(oValue == undefined); //output "true"  </pre>
</div>
<p>这段代码显示为true，代表oVlaue的值即为undefined，因为我们没有初始化它。</p>
<p>js 代码</p>
<div>
<pre class="prettyprint linenums">alert(null == document.getElementById('notExistElement'));  </pre>
</div>
<p>当页面上不存在id为"notExistElement"的DOM节点时，这段代码显示为"true"，因为我们尝试获取一个不存在的对象。</p>
<p>js 代码</p>
<div>
<pre class="prettyprint linenums">alert(typeof undefined); //output "undefined"<br />
alert(typeof null); //output "object"  </pre>
</div>
<p>第一行代码很容易理解，undefined的类型为Undefined；第二行代码却让人疑惑，为什么null的类型又是Object了呢？其实这是JavaScript最初实现的一个错误，后来被ECMAScript沿用下来。在今天我们可以解释为，null即是一个不存在的对象的占位符，但是在实际编码时还是要注意这一特性。</p>
<div>js 代码</div>
<div>
<div>
<pre class="prettyprint linenums">alert(null == undefined); //output "true"  </pre>
</div>
</div>
<p>ECMAScript认为undefined是从null派生出来的，所以把它们定义为相等的。但是，如果在一些情况下，我们一定要区分这两个值，那应该怎么办呢？可以使用下面的两种方法。</p>
<div>js 代码</div>
<div>
<div>
<pre class="prettyprint linenums">alert(null === undefined); //output "false"<br />
alert(typeof null == typeof undefined); //output "false"  </pre>
</div>
</div>
<p>使用typeof方法在前面已经讲过，null与undefined的类型是不一样的，所以输出"false"。而===代表绝对等于，在这里null === undefined输出false。</p>
<h2>==和===</h2>
<p>简单来说： == 代表相同， ===代表严格相同, 为啥这么说呢，</p>
<p>这么理解： 当进行双等号比较时候： 先检查两个操作数数据类型，如果相同， 则进行===比较， 如果不同， 则愿意为你进行一次类型转换， 转换成相同类型后再进行比较， 而===比较时， 如果类型不同，直接就是false。</p>
<p>操作数1 == 操作数2，&nbsp;&nbsp;操作数1 === 操作数2</p>
<p>比较过程：</p>
<p>　　双等号==：</p>
<p>　　（1）如果两个值类型相同，再进行三个等号(===)的比较。</p>
<p>　　（2）如果两个值类型不同，也有可能相等，需根据以下规则进行类型转换在比较：</p>
<p>　　　　1）如果一个是null，一个是undefined，那么相等。</p>
<p>　　　　2）如果一个是字符串，一个是数值，把字符串转换成数值之后再进行比较。</p>
<p>　　三等号===：</p>
<p>　　（1）如果类型不同，就一定不相等。</p>
<p>　　（2）如果两个都是数值，并且是同一个值，那么相等；如果其中至少一个是NaN，那么不相等。（判断一个值是否是NaN，只能使用isNaN( ) 来判断）。</p>
<p>　　（3）如果两个都是字符串，每个位置的字符都一样，那么相等，否则不相等。</p>
<p>　　（4）如果两个值都是true，或是false，那么相等。</p>
<p>　　（5）如果两个值都引用同一个对象或是函数，那么相等，否则不相等。</p>
<p>　　（6）如果两个值都是null，或是undefined，那么相等。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93jww83.html">ASP&period;NET中画图形验证码</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4y3z5q.html">knockout学习笔记目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq41o6nq.html">pageX&sol;Y&comma; offset&lpar;&rpar;&comma; position&lpar;&rpar;&comma; scrollTop&lpar;&rpar;&comma; screenX&sol;Y&comma; clientX&sol;Y&comma; pageX&sol;Y</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdex2g79.html">【9】了解Bootstrap栅格系统基础案例（4）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpwv70q.html">SublimeText编辑器替代notepad&plus;&plus;了</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zw14e9.html">Java并发系列&lbrack;2&rsqb;----AbstractQueuedSynchronizer源码分析之独占模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpvkyvq.html">Node&period;js 工具模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5zopdq.html">本地pip 源搭建起来</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv214ny9.html">nginx 配置文件学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rpz4z8.html">flutte项目命令行打包</a>
		</li>
						<li><a href="https://www.batexi.com/a/95glz5vq.html">C&num; Redis缓存过期实现延迟通知实战演练</a>
		</li>
						<li><a href="https://www.batexi.com/a/93weg30q.html">Jmeter（三十九）获取响应结果中参数出现的次数（转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90ro3p39.html">使用PerfView监测&period;NET程序性能（三）：分组</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vr5ozq.html">TCP&lowbar;Wrappers</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emm1vm9.html">plsql连接远程oracle和like无法查询中文问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/902d1n4q.html">SocketAsyncEventArgs的释放问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kodnj5q.html">利用Array Prototype的方法来实现对dom集合的筛选、indexOf、map等功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql176n69.html">Sequential projection learning for hashing阅读笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p2ey3q.html">【快速查阅】Linux下启动和关闭Weblogic（管理服务器&plus;被管服务器）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk7gwx8.html">最小生成树的变形（次小生成树hdu4081）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q4zlkp39.html">Linux 下 MySQL-5&period;6&period;16 安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zkg7k9.html">MIUI11系统怎么样启用root权限的教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1z5ldq.html">UNIX环境高级编程、 现代操作系统概念</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj6k419.html">&period;net基础学java系列（五）慢性自杀 之 沉沦在IDE中</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1zgldq.html">sql--迁移条件数据和补全数值的一个流程</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj67p09.html">Pycharm下同一目录的py文件不能相互调用的原因分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me1zg0q.html">&period;&sol;graldew bash&colon; &period;&sol;gradlew&colon; No such file or directory</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m6nz48.html">数据库和Content Provider</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m6no48.html">php 解决file&lowbar;put&lowbar;contents 不生效</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jpegv8.html">IntelliJ IDEA：创建Java Web工程</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
